//+------------------------------------------------------------------+
//|                                                   SampleList.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Item da lista encadeada                                          |
//+------------------------------------------------------------------+
class CListItem
  {
private:
   int               m_ID;
   CListItem        *m_next;
   CListItem        *m_prev;
public:
                    ~CListItem();
   void              setID(int id){m_ID=id;}
   int               getID(){return(m_ID);}
   void              next(CListItem *item){m_next=item;}
   void              prev(CListItem *item){m_prev=item;}
   CListItem*        next(){return(m_next);}
   CListItem*        prev(){return(m_prev);}
  };
//+------------------------------------------------------------------+
//| Destruidor de itens                                              |
//+------------------------------------------------------------------+
CListItem::~CListItem(void)
  {
   if(CheckPointer(m_next)==POINTER_DYNAMIC)
     {
      delete(m_next);
      Print(__FUNCTION__," removendo um item com ID =", m_ID);
     }
   else
      Print(__FUNCTION__," o prximo item no foi definido para o item com o ID =", m_ID);

  }
//+------------------------------------------------------------------+
//| Lista Encadeada                                                  |
//+------------------------------------------------------------------+
class CList
  {
private:
   int               m_counter;
   CListItem        *m_first;
public:
                     CList(){m_counter=0;}
                    ~CList();
   void              addItem(CListItem *item);
   int               size(){return(m_counter);}
  };
//+------------------------------------------------------------------+
//| Destruidor da lista                                              |
//+------------------------------------------------------------------+
CList::~CList(void)
  {
   int ID=m_first.getID();
   if(CheckPointer(m_first)==POINTER_DYNAMIC) delete(m_first);
   Print(__FUNCTION__," o primeiro item com ID =", ID, " destrudo");
  }
//+------------------------------------------------------------------+
//| Adicionando um tem  lista                                      |
//+------------------------------------------------------------------+
CList::addItem(CListItem *item)
   {
//--- verificao de um ponteiro, ele deve estar correto
   if(CheckPointer(item)==POINTER_INVALID) return;
//--- aumentando o nmero de itens da lista
   m_counter++;
//--- Verificando se no h elementos na lista
   if(CheckPointer(m_first)!=POINTER_DYNAMIC)
     {
      m_first=item;
     }
   else
     {
      //--- Definindo para primeiro o ponteiro do intem anterior
      m_first.prev(item);
      //--- salvando um ponteiro do primeiro item atual
      CListItem *p=m_first;
      //--- colocando o item de entrada no lugar do primeiro elemento
      m_first=item;
      //--- definindo um ponteiro para o prximo item  no primeiro item na lista
      m_first.next(p);
     }
  }
//+------------------------------------------------------------------+
//| Funo incio do Script                                          |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   CList list;
   for(int i=0;i<7;i++)
     {
      CListItem *item=new CListItem;
      item.setID(i);
      list.addItem(item);
     }
     Print("H ",list.size()," itens na lista");
  }
//+------------------------------------------------------------------+